var http = require('http'),
	https = require('https');

module.exports = function(ins, callback) {
	var hostname   = ins.getOption(ins.check.hostname, ins.host.hostname, 'localhost'),
		url        = ins.getOption(ins.check.url, 'http://'+hostname+'/'),
		statusCode = ins.getOption(ins.check.status, 200),
		client     = 'https'===url.substr(0,5) ? https : http,
		domain     = require('domain').create();

	domain.on('error', function(error) {
		error = error.toString();
		callback(false, error, error, {});
	});

	domain.run(function() {

		client.get(url, function(res) {

			var status,
				msg = '',
				output,
				values;

			output = JSON.stringify({
				url: url,
				statusCode: res.statusCode,
				headers: res.headers
			}, null, 4);

			values = {
				statusCode: res.statusCode
			};

			msg = '['+res.statusCode+'] '+url;

			if(statusCode===res.statusCode) {
				status = true;
			} else {
				msg += ', expected '+statusCode;
				status = false;
			}

			// We don't actually read the respnse body.
			// Consume response data to prevent connection from staying open.
			res.resume();

			callback(status, msg, output, values);
		});

	});
};
